unit uBeaRLibMG;

interface

uses uGeneral, uMapGenerator;

type
  map_callback = procedure(x, y: Integer; Value: TCellType; opaque: Pointer); cdecl;

procedure gen_map(map_id, layer: Integer; Typ: TMapGenerator; Seed: Integer); cdecl;
procedure gen_map_cb(SizeX, SizeY: Integer; Typ: TMapGenerator; Seed: Integer; callback: map_callback; opaque: Pointer); cdecl;

implementation

uses bearlibmap;

procedure gen_map(map_id, layer: Integer; Typ: TMapGenerator; Seed: Integer); cdecl;
var
  SizeX, SizeY,I,J: Integer;
begin
  SizeX := map_width(map_id);
  SizeY := map_height(map_id);
  CreateMap(SizeX, SizeY, Typ, Seed);
  for I := 0 to SizeX - 1 do
    for J := 0 to SizeY - 1 do
      map_set(map_id, I, J, layer, Ord(Map[I+1][J+1]));
end;

procedure gen_map_cb(SizeX, SizeY: Integer; Typ: TMapGenerator; Seed: Integer; callback: map_callback; opaque: Pointer); cdecl;
var
  I,J: Integer;
begin
  CreateMap(SizeX, SizeY, Typ, Seed);
  for I := 0 to SizeX - 1 do
    for J := 0 to SizeY - 1 do
      callback(I, J, Map[I+1][J+1], opaque);
end;


end.

